package com.kingdee.eas.custom.synctask.handler;

import com.alibaba.fastjson.JSONObject;
import com.fasterxml.jackson.databind.ObjectMapper;
import com.kingdee.bos.BOSException;
import com.kingdee.bos.Context;
import com.kingdee.bos.dao.IObjectValue;
import com.kingdee.bos.metadata.entity.EntityViewInfo;
import com.kingdee.bos.metadata.entity.FilterInfo;
import com.kingdee.bos.metadata.entity.FilterItemInfo;
import com.kingdee.bos.metadata.entity.SelectorItemCollection;
import com.kingdee.bos.metadata.query.util.CompareType;
import com.kingdee.eas.base.permission.IUser;
import com.kingdee.eas.base.permission.UserFactory;
import com.kingdee.eas.base.permission.UserInfo;
import com.kingdee.eas.basedata.org.*;
import com.kingdee.eas.basedata.person.*;
import com.kingdee.eas.common.EASBizException;
import com.kingdee.eas.custom.synctask.ActionTypeEnum;
import com.kingdee.eas.custom.synctask.entity.PersonEntity;
import com.kingdee.eas.hr.affair.EmpEnrollBizBillEntry;
import com.kingdee.eas.hr.affair.EmpEnrollBizBillEntryFactory;
import com.kingdee.eas.hr.affair.EmpEnrollBizBillEntryInfo;
import com.kingdee.eas.hr.affair.IEmpEnrollBizBillEntry;
import com.kingdee.eas.hr.ats.AtsUtil;
import com.kingdee.eas.hr.base.EmployeeTypeInfo;
import com.kingdee.eas.hr.emp.*;
import com.kingdee.eas.hr.emp.web.handler.EmployeeListHandler;
import com.kingdee.eas.hr.org.JobLevelInfo;
import com.kingdee.shr.base.syssetting.context.SHRContext;
import com.kingdee.util.StringUtils;
import okhttp3.*;
import org.apache.commons.codec.digest.DigestUtils;
import org.apache.log4j.Logger;
import org.springframework.ui.ModelMap;

import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;
import java.io.FileInputStream;
import java.io.IOException;
import java.text.SimpleDateFormat;
import java.util.*;

/**
 * @author qingwu
 * @date 2024/10/24
 * @apiNote ԱϢάչ
 */
public class EmployeeListHandlerEx extends EmployeeListHandler {
    public static Logger logger = Logger.getLogger(EmployeeListHandlerEx.class);

    private Context ctx = SHRContext.getInstance().getContext();
    private Properties propt = new Properties();

    public EmployeeListHandlerEx() {
        try {
            this.propt.load(new FileInputStream("E:\\Kingdee\\eas\\server\\properties\\scy\\syncOAConfig.properties"));
            //propt.load(new FileInputStream(System.getProperty("EAS_HOME") + "/server/properties/scy/syncOAConfig.properties"));
        } catch (IOException e) {
            e.printStackTrace();
        }
    }

    public void syncPersonToOAAction(HttpServletRequest request, HttpServletResponse response, ModelMap modelMap) throws BOSException, IOException, EASBizException {
        String billIds = request.getParameter("billIds");
        //ͬ֯OA
        //SyncTranForOAFacadeFactory.getLocalInstance(ctx).syncOrgUnitToOA(billIds, null);
        _syncpersonToOA(billIds, null);
    }

    /**
     * ͬ֯
     * 1billIdsΪֵʱͬеĲݵOA
     * 2billIdsΪʱȫͬ֯ݵOA
     * 3actionΪʱݲͬ
     * 4actionΪʱжϲ״̬ǷΪʧЧʧЧִɾִͬб༭ͬ
     * 5òͬͬΪ
     *
     * @param billds
     * @param action
     * @throws BOSException
     */
    public void _syncpersonToOA(String billds, ActionTypeEnum action) throws BOSException, IOException, EASBizException {
        logger.error("_syncpersonToOA----------------------start");
        logger.error("_syncpersonToOA----------------------billds: " + billds);
        IPerson iPerson = PersonFactory.getLocalInstance(ctx);
        IPersonPosition iPersonPosition = PersonPositionFactory.getLocalInstance(ctx);
        List<PersonEntity> dataList = new ArrayList();
        //billIdsΪֵʱͬеĲݵOA
        FilterInfo filterInfo = null;
        if (!StringUtils.isEmpty(billds)) {
            Set<String> personIds = AtsUtil.toSet(billds);
            filterInfo = new FilterInfo();
            filterInfo.getFilterItems().add(new FilterItemInfo("id", personIds, CompareType.INCLUDE));
        }
        SelectorItemCollection sic = new SelectorItemCollection();
        sic.add("*");
        sic.add("person.number");
        sic.add("person.name");
        sic.add("person.id");
        sic.add("person.employeeType.number");
        sic.add("personDep.name");
        sic.add("personDep.number");
        sic.add("personDep.id");
        sic.add("jobLevel.name");
        sic.add("jobLevel.number");
        sic.add("primaryPosition.id");
        sic.add("primaryPosition.name");
        sic.add("primaryPosition.number");
        sic.add("primaryPosition.job.name");
        sic.add("primaryPosition.job.number");
        sic.add("primaryPosition.job.jobType.name");
        sic.add("primaryPosition.job.jobType.number");
        EntityViewInfo entityViewInfo = EntityViewInfo.getInstance(filterInfo, sic, null);
        PersonPositionCollection personPositionCollection = iPersonPosition.getPersonPositionCollection(entityViewInfo);
        for (int i = 0; i < personPositionCollection.size(); i++) {
            //ְҵϢ
            PersonPositionInfo personPositionInfo = personPositionCollection.get(i);
            PersonEntity person = packagingPerson(personPositionInfo);
            dataList.add(person);
        }
        ObjectMapper mapper = new ObjectMapper();
        logger.error("_syncpersonToOA------------------dataList----- " + mapper.writeValueAsString(dataList));
        //ִͬ֯OA
        //executeSyncOrgUnitToOA(dataList);
    }

    /**
     * װԱ
     *
     * @param personPositionInfo
     * @return
     */
    public PersonEntity packagingPerson(PersonPositionInfo personPositionInfo) throws BOSException, EASBizException {
        SimpleDateFormat originalFormat = new SimpleDateFormat("yyyy-MM-dd");

        IUser iuser = UserFactory.getLocalInstance(ctx);
        //Ա
        PersonInfo personInfo = personPositionInfo.getPerson();
        //ԶԱʵ
        PersonEntity person = new PersonEntity();
        //
        person.setWorkcode(personInfo.getNumber());
        //Ա
        person.setLastname(personInfo.getName());
        //ֲ
        //person.setSubcompany("0");
        //
        AdminOrgUnitInfo personDep = personPositionInfo.getPersonDep();
        person.setDepartment(personDep.getName());
        //ֱϼ @todo
        person.setManagerid("");
        // @todo
        person.setAssistantid("");
        //״̬
        EmployeeTypeInfo employeeType = personInfo.getEmployeeType();
        String number = employeeType.getNumber();
        String personStatus = "";
        switch (number) {
            case "001": //ʽԱ
                personStatus = "ʽ";
                break;
            case "002": //Ա
                personStatus = "";
                break;
            case "S06": //ʱ
                personStatus = "ʱ";
                break;
            case "021": //Ƹ
                personStatus = "Ƹ";
                break;
            case "S09": //ְ
                personStatus = "ְ";
                break;
            case "011": //
                personStatus = "";
                break;
            default:
                personStatus = "Ч";
                break;
        }
        person.setStatus(personStatus);
        //칫ص @todo
        person.setLocationid("");
        //ƶ绰
        person.setMobile(personInfo.getCell());
        //칫ҵ绰
        person.setTelephone(personInfo.getOfficePhone());
        //ʼ
        person.setEmail(personInfo.getEmail());
        //ְ
        IEmpEnrollBizBillEntry iEmpEnrollBizBillEntry = EmpEnrollBizBillEntryFactory.getLocalInstance(ctx);
        EmpEnrollBizBillEntryInfo empEnrollBizBillEntryInfo = iEmpEnrollBizBillEntry.getEmpEnrollBizBillEntryInfo("person = '" + personInfo.getId() + "'");
        Date enrollDate = empEnrollBizBillEntryInfo.getEnrollDate();
        person.setCompanystartdate(originalFormat.format(enrollDate));
        //μӹ
        Date jobStartDate = empEnrollBizBillEntryInfo.getJobStartDate();
        person.setWorkstartdate(originalFormat.format(jobStartDate));
        UserInfo userInfo = iuser.getUserInfo("where person = '" + personInfo.getId() + "' ");
        //¼
        person.setLastname(userInfo.getName());
        //룬ת
        person.setPassword(userInfo.getPassword());
        //ȫ
        person.setSeclevel(3);
        //Ա
        IObjectValue personnelCa = (IObjectValue) personInfo.get("personnelCa");
        if (personnelCa != null) {
            Map customMap = new HashMap();
            customMap.put("field", personnelCa.get("name"));
            person.setWorkCustomData(customMap);
        }
        //ְ
        JobLevelInfo jobLevel = personPositionInfo.getJobLevel();
        person.setJoblevel(Integer.parseInt(jobLevel.getName()));
        return person;
    }

    /**
     * ִͬ֯OA
     *
     * @param dataList
     */
    public void executeSyncOrgUnitToOA(List dataList) throws IOException, BOSException {
        if (dataList != null && dataList.size() > 0) {
            ObjectMapper mapper = new ObjectMapper();
            //װ
            String data = mapper.writeValueAsString(dataList);
            String params = String.format("token = %s &data = %s", getToken(), data);
            logger.error("executeSyncOrgUnitToOA----------------------params" + params);
            //װ
            //String syncOrgUnitApiUrl = "/api/hrm/resful/synDepartment";
            String syncOrgUnitApiUrl = this.propt.getProperty("syncOrgUnitApiUrl");
            String url = this.propt.getProperty("url");
            logger.error("executeSyncOrgUnitToOA----------------------syncOrgUnitApiUrl" + syncOrgUnitApiUrl);
            if (StringUtils.isEmpty(syncOrgUnitApiUrl)) {
                throw new BOSException("ͬ֯OAӿڵַΪ!");
            }
            OkHttpClient client = new OkHttpClient();
            MediaType mediaType = MediaType.parse("application/x-www-form-urlencoded");
            RequestBody body = RequestBody.create(mediaType, params);
            Request request = new Request.Builder()
                    .url(url + syncOrgUnitApiUrl)
                    .post(body)
                    .addHeader("Content-Type", "application/json")
                    .addHeader("Accept", "*/*")
                    .addHeader("Accept-Encoding", "gzip, deflate, br")
                    .addHeader("User-Agent", "PostmanRuntime-ApipostRuntime/1.1.0")
                    .addHeader("Connection", "keep-alive")
                    .build();
            Response response = client.newCall(request).execute();
            String respBody = response.body().string();
            if (response.isSuccessful()) {

            } else {

            }
        }
    }

    /**
     * ȡtoken
     *
     * @return
     */
    public String getToken() {
        String key = this.propt.getProperty("key");
        long l = System.currentTimeMillis();//ʱ
        String code = key.concat(Long.toString(l));
        //String s = DigestUtils.md5Hex(code).toUpperCase();
        String s = DigestUtils.md5Hex(code).toUpperCase();
        Map<String, String> map = new HashMap<>();
        map.put("key", s);
        map.put("ts", Long.toString(l));
        logger.error("getToken" + JSONObject.toJSONString(map));
        return JSONObject.toJSONString(map);
    }
}
